﻿Imports System.ComponentModel
Imports System.Windows.Forms
Imports SwapRowTester.dtsSwapRowTester

Public Class frmSwapRowTester

	Public Sub New()
		InitializeComponent()
		If NotifyPropertyChanged.IsInDesignMode Then Return
		ControlStyling.StyleControls(Me)
		Dts.DataFile("..\..\DataStuff\dtsSwapRowTester.xml").Register(Me).Fill
		AutoMenu.Create(AddressOf Test, AddressOf Test2)
		For i = 0 To 3
			Dim cat = Dts.Kategorie.AddKategorieRow($"Kategorie_{i}")
			For ii = 0 To 3
				Dts.Artikel.AddArtikelRow($"{cat.Name}: Artikel_ {ii}", cat)
			Next
		Next
	End Sub

	Private Sub Test()
	End Sub
	Private Sub Test2()
	End Sub

	Private Sub Bt_Click(sender As Object, e As EventArgs) Handles btDown.Click, btUp.Click
		Dim i = bsKategorie.Position
		Dim twoRows() As DataRow = Nothing
		Select Case True
			Case sender Is btDown
				If i = bsKategorie.Count - 1 Then Return
				twoRows = {Dts.Kategorie(i), Dts.Kategorie(i + 1)}
				bsKategorie.Position += 1

			Case sender Is btUp
				If i = 0 Then Return
				twoRows = {Dts.Kategorie(i), Dts.Kategorie(i - 1)}
				bsKategorie.Position -= 1
			Case Else : Return
		End Select
		SwapRows(twoRows)
	End Sub

	Private Shared Sub SwapRows(twoRows() As DataRow)
		Dim rw0 = twoRows(0)
		Dim rw1 = twoRows(1)
		Dim itms = rw0.ItemArray
		'während des Tauschens müssen die ChildRelations auf UpdateRule.None stehen
		Dim ruleStore = Aggregate rel In rw0.Table.ChildRelations.Cast(Of DataRelation) Select rel, rel.ChildKeyConstraint.UpdateRule Into ToArray
		ruleStore.ForEach(Sub(inf) inf.rel.ChildKeyConstraint.UpdateRule = Rule.None)
		rw0.Table.DataSet.EnforceConstraints = False
		rw0.ItemArray = rw1.ItemArray
		rw1.ItemArray = itms
		rw0.Table.DataSet.EnforceConstraints = True
		ruleStore.ForEach(Sub(inf) inf.rel.ChildKeyConstraint.UpdateRule = inf.UpdateRule) ' UpdateRule restaurieren
	End Sub

End Class